@mixin x-box-shadow ($values...) {
           box-shadow: $values;
      -moz-box-shadow: $values;
   -webkit-box-shadow: $values;
        -o-box-shadow: $values;
       -ms-box-shadow: $values;
}

@mixin x-transition ($values...) {
	-webkit-transition: $values;
       -o-transition: $values;
     -moz-transition: $values;
	        transition: $values;
}

@mixin x-transform ($values) {
	-webkit-transform: $values; // Chrome, Safari, iOS Safari, Android Stock
	    -ms-transform: $values; // IE9
     -moz-transform: $values;
       -o-transform: $values;
	        transform: $values;
}

@mixin x-transform-origin ($values) {
      moz-transform-origin: $values;
	     -o-transform-origin: $values;
	    -ms-transform-origin: $values;
	-webkit-transform-origin: $values;
          transform-origin: $values;
}


@mixin x-display-flex {
	display: -webkit-box;  // Chrome 20-, iOS 6-, Safari 3.1  -6
	display: -moz-box;     // FF 19-
	display: -webkit-flex; // Chrome 21 - 28
	display: -ms-flexbox;  // IE 10
	display: flex;         // FF 20+, Chrome 29+, Opera 12.1, 17+
}

@mixin x-flex-wrap ($value) {
	// IE 10
	@if $value == nowrap {
		-ms-flex-wrap: none;
	} @else {
		-ms-flex-wrap: $value;
	}
	-webkit-flex-wrap: $value; // Chrome 20-, iOS 6-, Safari 3.1 - 6
	        flex-wrap: $value; // FF 28+, Chrome 21+, Opera 12.1, 17+, IE 11
}

@mixin x-align-content ($value) {
 // IE 10
 @if $value == flex-start {
   -ms-flex-line-pack: start;
 } @else if $value == flex-end {
   -ms-flex-line-pack: end;
 } @else if $value == space-between {
   -ms-flex-line-pack: justify;
 } @else if $value == space-around {
   -ms-flex-line-pack: distribute;
 } @else {
   -ms-flex-line-pack: $value;
 }
 -webkit-align-content: $value; // Chrome 20-, iOS 6-, Safari 3.1 - 6
    -moz-align-content: $value; // FF 19-
         align-content: $value; // FF 20+, Chrome 21+, Opera 12.1, 17+, IE 11
}

@mixin x-justify-content($value) {
  -webkit-justify-content: $value;
     -moz-justify-content: $value;
      -ms-justify-content: $value;
          justify-content: $value;
            -ms-flex-pack: $value;
}

@mixin x-align-items($value) {
  -webkit-align-items: $value;
     -moz-align-items: $value;
      -ms-align-items: $value;
          align-items: $value;
}

@mixin x-flex-direction ($value) {
	@if $value == row {
		-webkit-box-direction: normal;
		   -moz-box-direction: normal;
		   -webkit-box-orient: horizontal;
		      -moz-box-orient: horizontal;
	} @elseif $value == row-reverse {
		-webkit-box-direction: reverse;
		   -moz-box-direction: reverse;
		   -webkit-box-orient: horizontal;
		      -moz-box-orient: horizontal;
	} @elseif $value == column {
		-webkit-box-direction: normal;
		   -moz-box-direction: normal;
		   -webkit-box-orient: vertical;
		      -moz-box-orient: vertical;
	} @elseif $value == column-reverse {
		-webkit-box-direction: reverse;
		   -moz-box-direction: reverse;
		   -webkit-box-orient: vertical;
		      -moz-box-orient: vertical;
	}

 	-webkit-flex-direction: $value;
 	   -moz-flex-direction: $value;
 	    -ms-flex-direction: $value;
 	        flex-direction: $value;
 }

@mixin position-variant($position, $args) {
  @each $o in top right bottom left {
    $i: index($args, $o);
    @if $i and $i + 1 <= length($args) and type-of(nth($args, $i + 1)) == number {
      #{$o}: nth($args, $i + 1);
    }
  }
  position: $position;
}

@mixin absolute($args: '') {
  @include position-variant(absolute, $args);
}

@mixin fixed($args: '') {
  @include position-variant(fixed, $args);
}

@mixin relative($args: '') {
  @include position-variant(relative, $args);
}


@mixin font-face($font-name, $file-name, $weight: normal, $style: normal) {
  @font-face {
    font-family: quote($font-name);
    font-style: $style;
    font-weight: $weight;
    src: url($file-name + '.eot');
    src:
      url($file-name + '.eot?#iefix') format('embedded-opentype'),
      url($file-name + '.woff') format('woff'),
      url($file-name + '.ttf') format('truetype'),
      url($file-name + '.svg##{$font-name}') format('svg');
  }
}
